Summary: Tracks and displays system calls associated with a running process
Name: strace
Version: 4.24
Release: 7%{?dist}
# The test suite is GPLv2+, all the rest is LGPLv2.1+.
License: LGPL-2.1+ and GPL-2.0+
Group: Development/Debuggers
URL: https://strace.io/
Source: https://strace.io/files/%{version}/%{name}-%{version}.tar.xz

BuildRequires: libacl-devel time gzip
BuildRequires: pkgconfig(bluez)
BuildRequires: elfutils-devel binutils-devel

## General bug fixes
# v4.25~91 "evdev: fix decoding of bit sets"
Patch1:  0001-evdev-fix-decoding-of-bit-sets.patch
# v4.25~90 "evdev: fix decoding of EVIOCGBIT(0, ...)"
Patch2:  0002-evdev-fix-decoding-of-EVIOCGBIT-0.patch
# v4.25~83 "xlat: fix typo in smc_protocols.in"
Patch3:  0003-xlat-fix-typo-in-smc_protocols.in.patch

## Pre-requisite for the queueing patch
# v4.25~82 "strace.c: introduce struct tcb_wait_data"
Patch4:  0004-strace.c-introduce-struct-tcb_wait_data.patch

## Documentation
# v4.26~83 "Document -X option in strace -h output"
Patch5:  0005-Document-X-option-in-strace-h-output.patch

## Addresses https://bugzilla.redhat.com/1660759 ("strace prints "xlat_idx:
## Unexpected xlat value 0 at index 4" messages")
# v4.26~36 "evdev: fix off-by-one error in decode_bitset"
Patch6:  0006-evdev-fix-off-by-one-error-in-decode_bitset.patch
# v4.26~35 "nlattr: fix off-by-one error in indexed xlat lookup"
Patch7:  0007-nlattr-fix-off-by-one-error-in-indexed-xlat-lookup.patch
# v4.26~34 "aio: fix off-by-one error in indexed xlat lookup"
Patch8:  0008-aio-fix-off-by-one-error-in-indexed-xlat-lookup.patch
# v4.26~31 "rtnl_link: fix off-by-one errors in indexed and sorted xlat lookups"
Patch9:  0009-rtnl_link-fix-off-by-one-errors-in-indexed-and-sorte.patch
# v4.26~30 "rtnl_link: fix off-by-one errors in indexed and sorted xlat lookups"
Patch10: 0010-xlat_idx-do-not-issue-warnings-for-holes-in-indices.patch

## man page updates
# v4.26~27 "strace.1.in: print names of entities in bold, provide man page sections"
Patch11: 0011-strace.1.in-print-names-of-entities-in-bold-provide-.patch
# v4.26~26 "strace.1.in: consistently use CTRL-combinations"
Patch12: 0012-strace.1.in-consistently-use-CTRL-combinations.patch

## License change
# v4.26~53 "tests: change the license to GPL-2.0-or-later"
Patch13: 0013-tests-change-the-license-to-GPL-2.0-or-later.patch
# v4.26~52 "Change the license of strace to LGPL-2.1-or-later"
Patch14: 0014-Change-the-license-of-strace-to-LGPL-2.1-or-later.patch

## Tests fixes, can be hit on newer kernels
# v5.0~95 "tests: use tail_alloc instead of calloc in bpf-obj_get_info_by_fd-prog*"
Patch15: 0015-tests-use-tail_alloc-instead-of-calloc-in-bpf-obj_ge.patch
# v5.0~94 "tests: fix prog_info initialization in bpf-obj_get_info_by_fd-prog*"
Patch16: 0016-tests-fix-prog_info-initialization-in-bpf-obj_get_in.patch

## General bug fixes
# v5.0~71 "Merge "<... resumed>" printing"
Patch17: 0017-Merge-.-resumed-printing.patch
# v5.0~69 "Use accessors for tcp->s_ent, return a stub struct if it is NULL"
Patch18: 0018-Use-accessors-for-tcp-s_ent-return-a-stub-struct-if-.patch
# v5.0~66 "syscall.c: set MEMORY_MAPPING_CHANGE in stub sysent"
Patch19: 0019-syscall.c-set-MEMORY_MAPPING_CHANGE-in-stub-sysent.patch

## Addresses https://bugzilla.redhat.com/1662936 ("strace reports
## 'ptrace(SYSCALL): No such process' on multi-threaded testcase on RHEL-8")
# v5.0~67 "Make inline message on failed restart attempt more verbose"
Patch20: 0020-Make-inline-message-on-failed-restart-attempt-more-v.patch
# v5.0~64 "ptrace_restart: do not print diagnostics when ptrace returns ESRCH"
Patch21: 0021-ptrace_restart-do-not-print-diagnostics-when-ptrace-.patch

## Pre-requisites for the queueing patch
# v5.0~60 "tests: add kill_child test"
Patch22: 0022-tests-add-kill_child-test.patch
# v5.0~30 "tests: move PTRACE_SEIZE check to a separate file"
Patch23: 0023-tests-move-PTRACE_SEIZE-check-to-a-separate-file.patch
# v5.0~29 "tests: check tracing of orphaned process group"
Patch24: 0024-tests-check-tracing-of-orphaned-process-group.patch
# v5.0~27 "tests: check tracing of looping threads"
Patch25: 0025-tests-check-tracing-of-looping-threads.patch

## Implementation of tcp queueing
## Addresses https://bugzilla.redhat.com/1609318 ("Some threads are not created
## when strace with -f option is executed") and all previous its incarnations
## (478419, 526740, 851457, 1610774).
# v5.0~26 "Add a generic list implementation"
Patch26: 0026-Add-a-generic-list-implementation.patch
# v5.0~25 "Implement queueing of threads before dispatching them"
Patch27: 0027-Implement-queueing-of-threads-before-dispatching-the.patch

## Pre-requisites for "evdev: fix array size calculation in decode_bitset_"
# v4.25~30 "macros: add ROUNDUP macro"
Patch28: 0028-macros-add-ROUNDUP-macro.patch
# v5.0~45 "util: update dumpstr" (only macros.h change)
Patch29: 0029-util-update-dumpstr.patch

## Reported by covscan
# v5.2-3-g7ada13f "evdev: avoid bit vector decoding on non-successful and 0 return codes"
Patch30: 0030-evdev-avoid-bit-vector-decoding-on-non-successful-an.patch
# v5.2-4-g96194ed "evdev: fix array size calculation in decode_bitset_"
Patch31: 0031-evdev-fix-array-size-calculation-in-decode_bitset_.patch

## Pre-requisite for "tests: test evdev bitset decoding more thoroughly"
# v4.25~89 "tests: check decoding of successful evdev ioctl"
Patch32: 0032-tests-check-decoding-of-successful-evdev-ioctl.patch

## Test for patches "evdev: avoid bit vector decoding on non-successful and 0
## return codes" and "evdev: fix array size calculation in decode_bitset_"
# v5.2-5-gcdd8206 "tests: test evdev bitset decoding more thoroughly"
Patch33: 0033-tests-test-evdev-bitset-decoding-more-thoroughly.patch

# v4.26~65 "s390x: beautify sthyi data tail prints"
Patch34: 0034-s390x-beautify-sthyi-data-tail-prints.patch

## Reported by covscan
# v5.2-84-g91281fec "v4l2: avoid shifting left a signed number by 31 bit"
Patch35: 0035-v4l2-avoid-shifting-left-a-signed-number-by-31-bit.patch
# v5.2~21 "syscall.c: avoid infinite loop in subcalls parsing"
Patch36: 0036-syscall.c-avoid-infinite-loop-in-subcalls-parsing.patch
# v5.2~19 "kvm: avoid bogus vcpu_info assignment in vcpu_register"
Patch37: 0037-kvm-avoid-bogus-vcpu_info-assignment-in-vcpu_registe.patch
# v5.4~97 "xlat: use unsgined type for mount_flags fallback values"
Patch38: 0038-xlat-use-unsgined-type-for-mount_flags-fallback-valu.patch

## Missing stack traces on attach (https://bugzilla.redhat.com/1788636)
## RHEL 7: https://bugzilla.redhat.com/1790052
## RHEL 8: https://bugzilla.redhat.com/1790053
## RHEL 6 DTS: https://bugzilla.redhat.com/1790058
## RHEL 7 DTS: https://bugzilla.redhat.com/1790057
## RHEL 8 DTS: https://bugzilla.redhat.com/1790054
# v5.4-18-g69b2c33 "unwind-libdw: fix initialization of libdwfl cache"
Patch39: 0039-unwind-libdw-fix-initialization-of-libdwfl-cache.patch
# v5.4-63-g8e515c7 "tests: add strace-k-p test"
Patch41: 0041-tests-add-strace-k-p-test.patch

## Some ipc tests from strace internal testsuite occasionally fail
## https://bugzilla.redhat.com/1795251 https://bugzilla.redhat.com/1795261
## https://bugzilla.redhat.com/1794490 https://bugzilla.redhat.com/1795273
# v5.3~102 "tests: fix expected output for some ipc tests"
Patch43: 0043-tests-fix-expected-output-for-some-ipc-tests.patch
# v5.4~49 "tests: fix -a argument in ipc_msgbuf-Xraw test"
Patch44: 0044-tests-fix-a-argument-in-ipc_msgbuf-Xraw-test.patch

# v5.15~1 "print_ifindex: fix IFNAME_QUOTED_SZ definition"
Patch167: 0167-print_ifindex-fix-IFNAME_QUOTED_SZ-definition.patch

## RHEL-only: headers on some builders do not provide O_TMPFILE
Patch200: 0200-strace-provide-O_TMPFILE-fallback-definition.patch
## RHEL-only: aarch64 brew builders are extremely slow on qual_fault.test
Patch201: 0201-limit-qual_fault-scope-on-aarch64.patch


# In the past we had a separate strace64 package, these days the
# stndard 64 bit build provides that functionality.  For tracing
# 32 bit applications on ppc and s390 we still have strace32
Obsoletes: strace64

%define strace32_arches ppc s390

%description
The strace program intercepts and records the system calls called and
received by a running process.  Strace can print a record of each
system call, its arguments and its return value.  Strace is useful for
diagnosing problems and debugging, as well as for instructional
purposes.

Install strace if you need a tool to track the system calls made and
received by a process.

%ifarch %{strace32_arches}
%package -n strace32
Summary: Tracks and displays system calls associated with a running process.
Group: Development/Debuggers

%description -n strace32
The strace program intercepts and records the system calls called and
received by a running process.  Strace can print a record of each
system call, its arguments and its return value.  Strace is useful for
diagnosing problems and debugging, as well as for instructional
purposes.

Install strace if you need a tool to track the system calls made and
received by a process.

This package provides the `strace32' 32-bit program to trace 32-bit processes on
64-bit IBM P and Z series platforms.  Note that the regular 64-bit `strace'
binary supports tracing of 32-bit processes as well.
%endif

%prep
%setup -q

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch41 -p1
%patch43 -p1
%patch44 -p1
%patch167 -p1

%patch200 -p1
%patch201 -p1

echo -n %version-%release > .tarball-version
echo -n 2019 > .year
echo -n 2019-08-01 > .strace.1.in.date


%build
echo 'BEGIN OF BUILD ENVIRONMENT INFORMATION'
uname -a |head -1
libc="$(ldd /bin/sh |sed -n 's|^[^/]*\(/[^ ]*/libc\.so[^ ]*\).*|\1|p' |head -1)"
$libc |head -1
file -L /bin/sh
gcc --version |head -1
ld --version |head -1
kver="$(printf '%%s\n%%s\n' '#include <linux/version.h>' 'LINUX_VERSION_CODE' | gcc -E -P -)"
printf 'kernel-headers %%s.%%s.%%s\n' $(($kver/65536)) $(($kver/256%%256)) $(($kver%%256))
echo 'END OF BUILD ENVIRONMENT INFORMATION'

# -DHAVE_S390_COMPAT_REGS is needed due to lack of v3.10-rc1~201^2~11
CFLAGS=" $RPM_OPT_FLAGS $LDFLAGS "
# Removing explicit -m64 as it breaks mpers
[ "x${CFLAGS#* -m64 }" = "x${CFLAGS}" ] || CFLAGS=$(echo "$CFLAGS" | sed 's/ -m64 / /g')
export CFLAGS

CPPFLAGS=" -I%{_includedir} %{optflags} "
# Removing explicit -m64 as it breaks mpers
[ "x${CPPFLAGS#* -m64 }" = "x${CPPFLAGS}" ] || CPPFLAGS=$(echo "$CPPFLAGS" | sed 's/ -m64 / /g')
export CPPFLAGS

CFLAGS_FOR_BUILD="$RPM_OPT_FLAGS"; export CFLAGS_FOR_BUILD
# Commit v4.26-50-gb1a2db9 is needed for enforcing libiberty usage with
# --with-libiberty
%configure --enable-mpers=check --with-libdw
make %{?_smp_mflags}


%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install

# remove unpackaged files from the buildroot
rm -f %{buildroot}%{_bindir}/strace-graph

# some say uncompressed changelog files are too big
for f in ChangeLog ChangeLog-CVS; do
        gzip -9n < "$f" > "$f".gz &
done
wait

%define copy64 ln
%if 0%{?rhel}
%if 0%{?rhel} < 6
%endif
%define copy64 cp -p
%endif

%ifarch %{strace32_arches}
%{copy64} %{buildroot}%{_bindir}/strace %{buildroot}%{_bindir}/strace32
%endif

%check
# This is needed since patch does not set x bit to the newly created files
# (0022-tests-add-kill_child-test.patch,
#  0024-tests-check-tracing-of-orphaned-process-group.patch,
#  0025-tests-check-tracing-of-looping-threads.patch,
#  0032-tests-check-decoding-of-successful-evdev-ioctl.patch)
chmod u+x tests/*.test tests-m32/*.test tests-mx32/*.test

%{buildroot}%{_bindir}/strace -V


uname_r="$(uname -r)"
# Skip tests on s390x el6 kernel, test failures there are covered
# by the following issues:
#  * https://bugzilla.redhat.com/show_bug.cgi?id=1220802
#  * Absence of Linux commit v3.2-rc1~109^2~34
if [ "x${uname_r#2.6.32}" != "x${uname_r}" ] && \
   [ "x${uname_r%s390x}" != "x${uname_r}" ]
then
	echo "Skipping tests, kernel (${uname_r}) is too broken"
%ifarch s390
# Skip tests on s390:
#  * strace test suite used to rely too much on the fact that the last page
#    is unreadable, and apparently it is readable on s390 compat
#  * 16-bit set*id calls seem to be broken:
#    setugid.c:65: setuid(0xffff03e5) = -1 != 0: Operation not permitted
#    setresugid.c:79: setresgid(0xffff0087, 0x87, 0x87): Operation not permitted
#    (at least v4.16-rc1~117^2~1 is missing)
elif [ "x${uname_r%s390}" != "x${uname_r}" -o "x${uname_r%s390x}" != "x${uname_r}" ]
then
	echo "Skipping tests, test suite and kernel (${uname_r}) are too broken"
%endif
else
	# We have to limit concurrent execution of tests as some time-sensitive
	# tests start to fail if the reported time is way too off
	# from the expected one.
	make -j2 -k check VERBOSE=1 V=1 TIMEOUT_DURATION=5400
	tail -n 99999 -- tests*/test-suite.log tests*/ksysent.log
	find tests* -type f -name '*.log' -print0 |
		xargs -r0 grep -H '^KERNEL BUG:' -- ||:
	echo 'END OF TEST SUITE INFORMATION'
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc CREDITS ChangeLog.gz ChangeLog-CVS.gz COPYING LGPL-2.1-or-later NEWS README
%{_bindir}/strace
%{_bindir}/strace-log-merge
%{_mandir}/man1/*

%ifarch %{strace32_arches}
%files -n strace32
%defattr(-,root,root)
%{_bindir}/strace32
%endif

%changelog
* Wed Jan 05 2022 Eugene Syromiatnikov <esyr@redhat.com> - 4.24-7
- Fix incorrect ifname printing buffer size (#2028146):
  e27b0677 "print_ifindex: fix IFNAME_QUOTED_SZ definition".

* Thu Apr 16 2020 Eugene Syromiatnikov <esyr@redhat.com> - 4.24-6
- Fix expected alignment for IPC tests (#1795261):
  4377e3a1 "tests: fix expected output for some ipc tests", and
  a75c7c4b "tests: fix -a argument in ipc_msgbuf-Xraw test".

* Thu Apr 16 2020 Eugene Syromiatnikov <esyr@redhat.com> - 4.24-5
- Fix printing stack traces for early syscalls on process attach (#1790052):
  69b2c33a "unwind-libdw: fix initialization of libdwfl cache" and
  8e515c74 "tests: add strace-k-p test".
- Add commit v5.4~97 "xlat: use unsgined type for mount_flags fallback values"
  (A leftover for #1747524).

* Fri Aug 30 2019 Eugene Syromiatnikov <esyr@redhat.com> - 4.24-4
- Include upstream patches that fix issues reported by covscan:
  91281fec "v4l2: avoid shifting left a signed number by 31 bit",
  522ad3a0 "syscall.c: avoid infinite loop in subcalls parsing", and
  9446038e "kvm: avoid bogus vcpu_info assignment in vcpu_register".
- Resolves: #1747524

* Fri Aug 30 2019 Eugene Syromiatnikov <esyr@redhat.com> - 4.24-3
- Include commit v4.26~65 "s390x: beautify sthyi data tail prints"
- Resolves: #1747475

* Thu Aug 29 2019 Eugene Syromiatnikov <esyr@redhat.com> - 4.24-2
- Copy over changes in tests/ioctl_evdev-success.c (from cdd8206a
  "tests: test evdev bitset decoding more thoroughly")
  to tests-m32/ioctl_evdev-success.c and tests-mx32/ioctl_evdev-success.c
- Copy over changes in tests/ioctl_evdev.c (from 5ee385e2
  "evdev: fix decoding of EVIOCGBIT(0, ...)") to tests-m32/ioctl_evdev.c
  and tests-mx32/ioctl_evdev.c
- Resolves: #1746478

* Thu Aug 01 2019 Eugene Syromiatnikov <esyr@redhat.com> - 4.24-1
- Rebase to strace 4.24. (#1659983)
- Enable stack unwinding (-k option). (#1655856)

* Sat Jul 21 2018 Eugene Syromiatnikov <esyr@redhat.com> - 4.12-9
- Patch files in tests-m32 and tests-mx32 as well. (#1600210)

* Thu Jul 19 2018 Eugene Syromiatnikov <esyr@redhat.com> - 4.12-8
- Update membarrier constants. (#1600210)

* Mon Apr 30 2018 Eugene Syromiatnikov <esyr@redhat.com> - 4.12-7
- Return non-zero exit code if no processes have been attached. (#1573034)

* Wed Feb  7 2018 DJ Delorie <dj@redhat.com> - 4.12-6
- Update membarrier constants. (#1540954)

* Thu Sep 14 2017 DJ Delorie <dj@redhat.com> - 4.12-5
- Handle unexpected CLONE_PTRACE events. (#1466535)
- Skip tests for s390/ppc64le as well as s390x/ppc64.

* Fri May 12 2017 DJ Delorie <dj@redhat.com> - 4.12-4
- Fix typo in btrfs detection logic.  (#1449935)

* Thu Apr 13 2017 DJ Delorie <dj@redhat.com> - 4.12-3
- Remove unneeded debug stuff. (#1377847)

* Mon Apr 10 2017 DJ Delorie <dj@redhat.com> - 4.12-2
- Adjust O_TMPFILE patch to include support even if the
  build-time headers don't have it. (#1377847)

* Tue Feb 21 2017 DJ Delorie <dj@redhat.com> - 4.12-1
- Rebase to strace 4.12, which fixes...
  + Support BLKPG_RESIZE_PARTITION (#1329673)
  + Support getrandom() (#1374268)
  + Fix endless loop in io_submit (#1165548)
- Merge upstream patches for vhangup and chown
- Skip some tests on older kernels (RHEL 6)
- Remove -m64 that rpm macros adds
- Show mode with O_TMPFILE (#1377847)

* Thu Jul 30 2015 Jeff Law <law@redhat.com> 4.8-11
- Fix race which caused follow-fork option to not always
  work (#1235833)

* Tue May 12 2015 Peter Robinson <pbrobinson@redhat.com> 4.8-10
- rebuild

* Fri Aug 15 2014 Jeff Law <law@redhat.com> 4.8-9
- Fix prototype for ptrace (#1129572)

* Fri Aug 1 2014 Jeff Law <law@redhat.com> 4.8-8
- update for ppc64 -- Dan Horak's patch from Fedora (#1122390)

* Fri Jan 24 2014 Daniel Mach <dmach@redhat.com> - 4.8-7
- Mass rebuild 2014-01-24

* Fri Dec 27 2013 Daniel Mach <dmach@redhat.com> - 4.8-6
- Mass rebuild 2013-12-27

* Wed Dec 18 2013 Jeff Law <law@redhat.com> 4.8-5
- Don't pass NULL pointers to strcmp when sorting by syscall
  name (#1044044)

* Thu Oct 3 2013 Jeff Law <law@redhat.com> - 4.8-4
- Build strace32 on ppc/s390 which can be installed alongside of strace
  on ppc64/s390x (#980229)

* Wed Jul 17 2013 Jeff Law <law@redhat.com> - 4.8-3
- Refetch registers in collect_stopped_tcbs (#971352)

* Wed Jun 12 2013 Jeff Law <ldv@altlinux.org> - 4.8-2
- Don't dereference dropped TCP (#971352).  From
  Jan Stancek.  Merged into patch for 851457.
- Disable "net" test as it is highly timing dependent
  Merge into patch 851457.
- Bring forward patches lost after resyncing with Fedora.
  - Patch to avoid strict aliasing warnings
  - Patch to add man page for strace-log-merge (#948577)
  - Patch to improve scheduling fairness (#851457)

* Mon Jun 03 2013 Dmitry V. Levin <ldv@altlinux.org> - 4.8-1
- New upstream release:
  + fixed ERESTARTNOINTR leaking to userspace on ancient kernels (#659382);
  + fixed decoding of *xattr syscalls (#885233);
  + fixed handling of files with 64-bit inode numbers by 32-bit strace (#912790);
  + added aarch64 support (#969858).

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed May 02 2012 Dmitry V. Levin <ldv@altlinux.org> 4.7-1
- New upstream release.
  + implemented proper handling of real SIGTRAPs (#162774).

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Mar 14 2011 Dmitry V. Levin <ldv@altlinux.org> - 4.6-1
- New upstream release.
  + fixed a corner case in waitpid handling (#663547).

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.5.20-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Apr 13 2010 Roland McGrath <roland@redhat.com> - 4.5.20-1
- New upstream release, work mostly by Andreas Schwab and Dmitry V. Levin.
  + fixed potential stack buffer overflow in select decoder (#556678);
  + fixed FTBFS (#539044).

* Wed Oct 21 2009 Roland McGrath <roland@redhat.com> - 4.5.19-1
- New upstream release, work mostly by Dmitry V. Levin <ldv@altlinux.org>
  + exit/kill strace with traced process exitcode/signal (#105371);
  + fixed build on ARM EABI (#507576);
  + fixed display of 32-bit argv array on 64-bit architectures (#519480);
  + fixed display of 32-bit fcntl(F_SETLK) on 64-bit architectures (#471169);
  + fixed several bugs in strings decoder, including potential heap
    memory corruption (#470529, #478324, #511035).

* Thu Aug 28 2008 Roland McGrath <roland@redhat.com> - 4.5.18-1
- build fix for newer kernel headers (#457291)
- fix CLONE_VFORK handling (#455078)
- Support new Linux/PPC system call subpage_prot and PROT_SAO flag.
- In sigaction system call, display sa_flags value along with SIG_DFL/SIG_IGN.

* Mon Jul 21 2008 Roland McGrath <roland@redhat.com> - 4.5.17-1
- handle O_CLOEXEC, MSG_CMSG_CLOEXEC (#365781)
- fix biarch stat64 decoding (#222275)
- fix spurious "..." in printing of environment strings (#358241)
- improve prctl decoding (#364401)
- fix hang wait on exited child with exited child (#354261)
- fix biarch fork/vfork (-f) tracing (#447475)
- fix biarch printing of negative argument kill (#430585)
- fix biarch decoding of error return values (#447587)
- fix -f tracing of CLONE_VFORK (#455078)
- fix ia64 register clobberation in -f tracing (#453438)
- print SO_NODEFER, SA_RESETHAND instead of SA_NOMASK, SA_ONESHOT (#455821)
- fix futex argument decoding (#448628, #448629)

* Fri Aug  3 2007 Roland McGrath <roland@redhat.com> - 4.5.16-1
- fix multithread issues (#240962, #240961, #247907)
- fix spurious SIGSTOP on early interrupt (#240986)
- fix utime for biarch (#247185)
- fix -u error message (#247170)
- better futex syscall printing (##241467)
- fix argv/envp printing with small -s settings, and for biarch
- new syscalls: getcpu, eventfd, timerfd, signalfd, epoll_pwait,
  move_pages, utimensat

* Tue Jan 16 2007 Roland McGrath <roland@redhat.com> - 4.5.15-1
- biarch fixes (#179740, #192193, #171626, #173050, #218433, #218043)
- fix -ff -o behavior (#204950, #218435, #193808, #219423)
- better quotactl printing (#118696)
- *at, inotify*, pselect6, ppoll and unshare syscalls (#178633, #191275)
- glibc-2.5 build fixes (#209856)
- memory corruption fixes (#200621
- fix race in child setup under -f (#180293)
- show ipc key values in hex (#198179, #192182)
- disallow -c with -ff (#187847)
- Resolves: RHBZ #179740, RHBZ #192193, RHBZ #204950, RHBZ #218435
- Resolves: RHBZ #193808, RHBZ #219423, RHBZ #171626, RHBZ #173050
- Resolves: RHBZ #218433, RHBZ #218043, RHBZ #118696, RHBZ #178633
- Resolves: RHBZ #191275, RHBZ #209856, RHBZ #200621, RHBZ #180293
- Resolves: RHBZ #198179, RHBZ #198182, RHBZ #187847

* Mon Nov 20 2006 Jakub Jelinek <jakub@redhat.com> - 4.5.14-4
- Fix ia64 syscall decoding (#206768)
- Fix build with glibc-2.4.90-33 and up on all arches but ia64
- Fix build against 2.6.18+ headers

* Tue Aug 22 2006 Roland McGrath <roland@redhat.com> - 4.5.14-3
- Fix bogus decoding of syscalls >= 300 (#201462, #202620).

* Fri Jul 14 2006 Jesse Keating <jkeating@redhat.com> - 4.5.14-2
- rebuild

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 4.5.14-1.2
- bump again for long double bug on ppc{,64}

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 4.5.14-1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Jan 16 2006 Roland McGrath <roland@redhat.com> - 4.5.14-1
- Fix biarch decoding of socket syscalls (#174354).
- Fix biarch -e support (#173986).
- Accept numeric syscalls in -e (#174798).
- Fix ipc syscall decoding (#164755).
- Improve msgrcv printing (#164757).
- Man page updates (#165375).
- Improve mount syscall printing (#165377).
- Correct printing of restarting syscalls (#165469).

* Wed Aug  3 2005 Roland McGrath <roland@redhat.com> - 4.5.13-1
- Fix setsockopt decoding on 64-bit (#162449).
- Fix typos in socket option name strings (#161578).
- Display more IPV6 socket options by name (#162450).
- Don't display inappropriate syscalls for -e trace=file (#159340).
- New selector type -e trace=desc for file-descriptor using calls (#159400).
- Fix 32-bit old_mmap syscall decoding on x86-64 (#162467, #164215).
- Fix errors detaching from multithreaded process on interrupt (#161919).
- Note 4.5.12 fix for crash handling bad signal numbers (#162739).

* Wed Jun  8 2005 Roland McGrath <roland@redhat.com> - 4.5.12-1
- Fix known syscall recognition for IA32 processes on x86-64 (#158934).
- Fix bad output for ptrace on x86-64 (#159787).
- Fix potential buffer overruns (#151570, #159196).
- Make some diagnostics more consistent (#159308).
- Update PowerPC system calls.
- Better printing for Linux aio system calls.
- Don't truncate statfs64 fields to 32 bits in output (#158243).
- Cosmetic code cleanups (#159688).

* Tue Mar 22 2005 Roland McGrath <roland@redhat.com> - 4.5.11-1
- Build tweaks.
- Note 4.5.10 select fix (#151570).

* Mon Mar 14 2005 Roland McGrath <roland@redhat.com> - 4.5.10-1
- Fix select handling on nonstandard fd_set sizes.
- Don't print errors for null file name pointers.
- Fix initial execve output with -i (#143365).

* Fri Feb  4 2005 Roland McGrath <roland@redhat.com> - 4.5.9-2
- update ia64 syscall list (#146245)
- fix x86_64 syscall argument extraction for 32-bit processes (#146093)
- fix -e signal=NAME parsing (#143362)
- fix x86_64 exit_group syscall handling
- improve socket ioctl printing (#138223)
- code cleanups (#143369, #143370)
- improve mount flags printing (#141932)
- support symbolic printing of x86_64 arch_prctl parameters (#142667)
- fix potential crash in getxattr printing

* Tue Oct 19 2004 Roland McGrath <roland@redhat.com> - 4.5.8-1
- fix multithreaded exit handling (#132150, #135254)
- fix ioctl name matching (#129808)
- print RTC_* ioctl structure contents (#58606)
- grok epoll_* syscalls (#134463)
- grok new RLIMIT_* values (#133594)
- print struct cmsghdr contents for sendmsg (#131689)
- fix clock_* and timer_* argument output (#131420)

* Tue Aug 31 2004 Roland McGrath <roland@redhat.com> - 4.5.7-2
- new upstream version, misc fixes and updates (#128091, #129166, #128391, #129378, #130965, #131177)

* Mon Jul 12 2004 Roland McGrath <roland@redhat.com> 4.5.6-1
- new upstream version, updates ioctl lists (#127398), fixes quotactl (#127393), more ioctl decoding (#126917)

* Sun Jun 27 2004 Roland McGrath <roland@redhat.com> 4.5.5-1
- new upstream version, fixes x86-64 biarch support (#126547)

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com> 4.5.4-2
- rebuilt

* Thu Jun  3 2004 Roland McGrath <roland@redhat.com> 4.5.4-0.FC1
- rebuilt for FC1 update

* Thu Jun  3 2004 Roland McGrath <roland@redhat.com> 4.5.4-1
- new upstream version, more ioctls (#122257), minor fixes

* Fri Apr 16 2004 Roland McGrath <roland@redhat.com> 4.5.3-1
- new upstream version, mq_* calls (#120701), -p vs NPTL (#120462), more fixes (#118694, #120541, #118685)

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com> 4.5.2-1.1
- rebuilt

* Mon Mar  1 2004 Roland McGrath <roland@redhat.com> 4.5.2-1
- new upstream version, sched_* calls (#116990), show core flag (#112117)

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Nov 13 2003 Roland McGrath <roland@redhat.com> 4.5.1-1
- new upstream version, more fixes (#108012, #105366, #105359, #105358)

* Tue Sep 30 2003 Roland McGrath <roland@redhat.com> 4.5-3
- revert bogus s390 fix

* Thu Sep 25 2003 Roland McGrath <roland@redhat.com> 4.5-1.2.1AS
- rebuilt for 2.1AS erratum

* Wed Sep 24 2003 Roland McGrath <roland@redhat.com> 4.5-2
- rebuilt

* Wed Sep 24 2003 Roland McGrath <roland@redhat.com> 4.5-1
- new upstream version, more fixes (#101499, #104365)

* Thu Jul 17 2003 Roland McGrath <roland@redhat.com> 4.4.99-2
- rebuilt

* Thu Jul 17 2003 Roland McGrath <roland@redhat.com> 4.4.99-1
- new upstream version, groks more new system calls, PF_INET6 sockets

* Tue Jun 10 2003 Roland McGrath <roland@redhat.com> 4.4.98-1
- new upstream version, more fixes (#90754, #91085)

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Sun Mar 30 2003 Roland McGrath <roland@redhat.com> 4.4.96-1
- new upstream version, handles yet more 2.5 syscalls, x86_64 & ia64 fixes

* Mon Feb 24 2003 Elliot Lee <sopwith@redhat.com> 4.4.95-2
- rebuilt

* Mon Feb 24 2003 Roland McGrath <roland@redhat.com> 4.4.95-1
- new upstream version, fixed getresuid/getresgid (#84959)

* Wed Feb 19 2003 Roland McGrath <roland@redhat.com> 4.4.94-1
- new upstream version, new option -E to set environment variables (#82392)

* Wed Jan 22 2003 Tim Powers <timp@redhat.com> 4.4.93-2
- rebuilt

* Tue Jan 21 2003 Roland McGrath <roland@redhat.com> 4.4.93-1
- new upstream version, fixes ppc and s390 bugs, adds missing ptrace requests

* Fri Jan 10 2003 Roland McGrath <roland@redhat.com> 4.4.91-1
- new upstream version, fixes -f on x86-64

* Fri Jan 10 2003 Roland McGrath <roland@redhat.com> 4.4.90-1
- new upstream version, fixes all known bugs modulo ia64 and s390 issues

* Fri Jan 03 2003 Florian La Roche <Florian.LaRoche@redhat.de> 4.4-11
- add further s390 patch from IBM

* Wed Nov 27 2002 Tim Powers <timp@redhat.com> 4.4-10
- remove unpackaged files from the buildroot

* Mon Oct 07 2002 Phil Knirsch <pknirsch@redhat.com> 4.4-9.1
- Added latest s390(x) patch.

* Fri Sep 06 2002 Karsten Hopp <karsten@redhat.de> 4.4-9
- preliminary x86_64 support with an ugly patch to help
  debugging. Needs cleanup!

* Mon Sep  2 2002 Jakub Jelinek <jakub@redhat.com> 4.4-8
- newer version of the clone fixing patch (Roland McGrath)
- aio syscalls for i386/ia64/ppc (Ben LaHaise)

* Wed Aug 28 2002 Jakub Jelinek <jakub@redhat.com> 4.4-7
- fix strace -f (Roland McGrath, #68994)
- handle ?et_thread_area, SA_RESTORER (Ulrich Drepper)

* Fri Jun 21 2002 Jakub Jelinek <jakub@redhat.com> 4.4-6
- handle futexes, *xattr, sendfile64, etc. (Ulrich Drepper)
- handle modify_ldt (#66894)

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue Apr 16 2002 Jakub Jelinek <jakub@redhat.com> 4.4-4
- fix for the last patch by Jeff Law (#62591)

* Mon Mar  4 2002 Preston Brown <pbrown@redhat.com> 4.4-3
- integrate patch from Jeff Law to eliminate hang tracing threads

* Sat Feb 23 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- minor update from debian tar-ball

* Wed Jan 02 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- update to 4.4

* Sun Jul 22 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- disable s390 patches, they are already included

* Wed Jul 18 2001 Preston Brown <pbrown@redhat.com> 4.3-1
- new upstream version.  Seems to have integrated most new syscalls
- tracing threaded programs is now functional.

* Mon Jun 11 2001 Than Ngo <than@redhat.com>
- port s390 patches from IBM

* Wed May 16 2001 Nalin Dahyabhai <nalin@redhat.com>
- modify new syscall patch to allocate enough heap space in setgroups32()

* Wed Feb 14 2001 Jakub Jelinek <jakub@redhat.com>
- #include <time.h> in addition to <sys/time.h>

* Fri Jan 26 2001 Karsten Hopp <karsten@redhat.com>
- clean up conflicting patches. This happened only
  when building on S390

* Fri Jan 19 2001 Bill Nottingham <notting@redhat.com>
- update to CVS, reintegrate ia64 support

* Fri Dec  8 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Get S/390 support into the normal package

* Sat Nov 18 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- added S/390 patch from IBM, adapting it to not conflict with
  IA64 patch

* Sat Aug 19 2000 Jakub Jelinek <jakub@redhat.com>
- doh, actually apply the 2.4 syscalls patch
- make it compile with 2.4.0-test7-pre4+ headers, add
  getdents64 and fcntl64

* Thu Aug  3 2000 Jakub Jelinek <jakub@redhat.com>
- add a bunch of new 2.4 syscalls (#14036)

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild
- excludearch ia64

* Fri Jun  2 2000 Matt Wilson <msw@redhat.com>
- use buildinstall for FHS

* Wed May 24 2000 Jakub Jelinek <jakub@redhat.com>
- make things compile on sparc
- fix sigreturn on sparc

* Fri Mar 31 2000 Bill Nottingham <notting@redhat.com>
- fix stat64 misdef (#10485)

* Tue Mar 21 2000 Michael K. Johnson <johnsonm@redhat.com>
- added ia64 patch

* Thu Feb 03 2000 Cristian Gafton <gafton@redhat.com>
- man pages are compressed
- version 4.2 (why are we keeping all these patches around?)

* Sat Nov 27 1999 Jeff Johnson <jbj@redhat.com>
- update to 4.1 (with sparc socketcall patch).

* Fri Nov 12 1999 Jakub Jelinek <jakub@redhat.com>
- fix socketcall on sparc.

* Thu Sep 02 1999 Cristian Gafton <gafton@redhat.com>
- fix KERN_SECURELVL compile problem

* Tue Aug 31 1999 Cristian Gafton <gafton@redhat.com>
- added alpha patch from HJLu to fix the osf_sigprocmask interpretation

* Sat Jun 12 1999 Jeff Johnson <jbj@redhat.com>
- update to 3.99.1.

* Wed Jun  2 1999 Jeff Johnson <jbj@redhat.com>
- add (the other :-) jj's sparc patch.

* Wed May 26 1999 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.99 in order to
-    add new 2.2.x open flags (#2955).
-    add new 2.2.x syscalls (#2866).
- strace 3.1 patches carried along for now.

* Sun May 16 1999 Jeff Johnson <jbj@redhat.com>
- don't rely on (broken!) rpm %%patch (#2735)

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- strip binary

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 16)

* Tue Feb  9 1999 Jeff Johnson <jbj@redhat.com>
- vfork est arrive!

* Tue Feb  9 1999 Christopher Blizzard <blizzard@redhat.com>
- Add patch to follow clone() syscalls, too.

* Sun Jan 17 1999 Jeff Johnson <jbj@redhat.com>
- patch to build alpha/sparc with glibc 2.1.

* Thu Dec 03 1998 Cristian Gafton <gafton@redhat.com>
- patch to build on ARM

* Wed Sep 30 1998 Jeff Johnson <jbj@redhat.com>
- fix typo (printf, not tprintf).

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- fix compile problem on sparc.

* Tue Aug 18 1998 Cristian Gafton <gafton@redhat.com>
- buildroot

* Mon Jul 20 1998 Cristian Gafton <gafton@redhat.com>
- added the umoven patch from James Youngman <jay@gnu.org>
- fixed build problems on newer glibc releases

* Mon Jun 08 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

